unit FatalExit;

{
	Make Fast Fatal Exit, for testing DebugEventTracer.

	Modify History:

	23.08.2002.

		+		Add genFatalExitFunction for testing


}


interface

{$DEFINE WINNT}

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ExtCtrls;

const

	authorId = '5S2J0J6H7H2P6Q0E0M187L247O0B102V';
	author = 'Copyright  2002-2003 by Monxla (monxla@coder.hu) author id:' + authorId;
	

type



	TSampleThread = class(TThread)
	private
	protected
		procedure Execute; override;
	public
	end;


	TdebuggertestForm = class(TForm)
		Panel1: TPanel;
		debugGroupBox: TGroupBox;
		debugStringButton: TButton;
		createProcessButton: TButton;
		exitProcessButton: TButton;
		Splitter1: TSplitter;
		errorGroupBox: TGroupBox;
		userObjectsOverflowButton: TButton;
		fatalExit2Button: TButton;
		stackOverflowErroButton: TButton;
		createThreadButton: TButton;
		exitThreadButton: TButton;
		loadDllButton: TButton;
		unloadDllButton: TButton;
    Panel2: TPanel;
    closeButton: TButton;
    divideByZeroErrorButton: TButton;
    invalidPtrErrorButton: TButton;
    handleCheckBox: TCheckBox;
		procedure FormCreate(Sender: TObject);
		procedure stackOverflowErroButtonClick(Sender: TObject);
		procedure userObjectsOverflowButtonClick(Sender: TObject);
		procedure fatalExit2ButtonClick(Sender: TObject);
		procedure debugStringButtonClick(Sender: TObject);
		procedure createProcessButtonClick(Sender: TObject);
		procedure exitProcessButtonClick(Sender: TObject);
    procedure createThreadButtonClick(Sender: TObject);
		procedure exitThreadButtonClick(Sender: TObject);
		procedure loadDllButtonClick(Sender: TObject);
		procedure unloadDllButtonClick(Sender: TObject);
		procedure divideByZeroErrorButtonClick(Sender: TObject);
		procedure invalidPtrErrorButtonClick(Sender: TObject);
    procedure closeButtonClick(Sender: TObject);

	private
		t1: TSampleThread;
		dllHandle: THandle;
		procCreated: boolean;
		startInfo: TStartupInfo;
		procInfo: TProcessInformation;
		function create_Window: cardinal;
		procedure genFatalExit;
		procedure callGenError;
		procedure genError;
		procedure recursiveCall;
	public
		{ Public declarations }
	end;



	TMsgHandler   = procedure (window, msg: cardinal; wParam, lParam: integer; var result: integer);
	TMsgHandlerOO = procedure (window, msg: cardinal; wParam, lParam: integer; var result: integer) of object;

	TMsgHandlers = array of record
		message   : cardinal;
		handler   : TMsgHandler;
		handlerOO : TMsgHandlerOO;
	end;


var
	debuggertestForm: TdebuggertestForm;
	MsgHandlerSection : PRTLCriticalSection = nil;
	MsgHandlerWindows : array of record
		threadID : cardinal;
		window   : cardinal;
		handlers : TMsgHandlers;
	 end;


function getOffsetBase: longword;

implementation

{$R *.DFM}


function getOffsetBase: longword;
var
	NTHeader: PImageFileHeader;
	NTOptHeader: PImageOptionalHeader;

	(* BASE TECHNICAL INFORMATIONS:

	The IMAGE_FILE_HEADER structure represents the COFF header format.
	(The COFF archive format provides a standard mechanism for storing collections of object files.)

	typedef struct _IMAGE_FILE_HEADER {
		WORD Machine;
		WORD NumberOfSections;
		DWORD TimeDateStamp;
		DWORD PointerToSymbolTable;
		DWORD NumberOfSymbols;
		WORD SizeOfOptionalHeader;
		WORD Characteristics;
	} IMAGE_FILE_HEADER, *PIMAGE_FILE_HEADER;

	The IMAGE_OPTIONAL_HEADER structure represents the optional header format.

	typedef struct _IMAGE_OPTIONAL_HEADER {
		WORD    Magic;
		BYTE    MajorLinkerVersion;
		BYTE    MinorLinkerVersion;
		DWORD   SizeOfCode;
		DWORD   SizeOfInitializedData;
		DWORD   SizeOfUninitializedData;
		DWORD   AddressOfEntryPoint;
		// Pointer to the beginning of the code section, relative to the image base.
		DWORD   BaseOfCode;
		DWORD   BaseOfData;
		DWORD   ImageBase;
		DWORD   SectionAlignment;
		DWORD   FileAlignment;
		WORD    MajorOperatingSystemVersion;
		WORD    MinorOperatingSystemVersion;
		WORD    MajorImageVersion;
		WORD    MinorImageVersion;
		WORD    MajorSubsystemVersion;
		WORD    MinorSubsystemVersion;
		DWORD   Win32VersionValue;
		DWORD   SizeOfImage;
		DWORD   SizeOfHeaders;
		DWORD   CheckSum;
		WORD    Subsystem;
		WORD    DllCharacteristics;
		DWORD   SizeOfStackReserve;
		DWORD   SizeOfStackCommit;
		DWORD   SizeOfHeapReserve;
		DWORD   SizeOfHeapCommit;
		DWORD   LoaderFlags;
		DWORD   NumberOfRvaAndSizes;
		IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
	} IMAGE_OPTIONAL_HEADER, *PIMAGE_OPTIONAL_HEADER;


	_IMAGE_DOS_HEADER = packed record      { DOS .EXE header                  }
			e_magic: Word;                     { Magic number                     }
			e_cblp: Word;                      { Bytes on last page of file       }
			e_cp: Word;                        { Pages in file                    }
			e_crlc: Word;                      { Relocations                      }
			e_cparhdr: Word;                   { Size of header in paragraphs     }
			e_minalloc: Word;                  { Minimum extra paragraphs needed  }
			e_maxalloc: Word;                  { Maximum extra paragraphs needed  }
			e_ss: Word;                        { Initial (relative) SS value      }
			e_sp: Word;                        { Initial SP value                 }
			e_csum: Word;                      { Checksum                         }
			e_ip: Word;                        { Initial IP value                 }
			e_cs: Word;                        { Initial (relative) CS value      }
			e_lfarlc: Word;                    { File address of relocation table }
			e_ovno: Word;                      { Overlay number                   }
			e_res: array [0..3] of Word;       { Reserved words                   }
			e_oemid: Word;                     { OEM identifier (for e_oeminfo)   }
			e_oeminfo: Word;                   { OEM information; e_oemid specific}
			e_res2: array [0..9] of Word;      { Reserved words                   }
			_lfanew: LongInt;                  { File address of new exe header   }
	end;

	*)

begin
	NTHeader := PImageFileHeader(Cardinal(PImageDosHeader(HInstance)._lfanew) + HInstance + 4);
	NTOptHeader := PImageOptionalHeader(Cardinal(NTHeader) + IMAGE_SIZEOF_FILE_HEADER);
	result:= HInstance + NTOptHeader.BaseOfCode;
end;

function dummyHandlerWindowProc(window, msg: cardinal; wParam, lParam: integer) : integer; stdcall;
var i1 : integer;
		mh : TMsgHandlers;
begin
	mh := nil;
	result := DefWindowProc(window, msg, wParam, lParam);
	if (msg in [WM_QUERYENDSESSION, WM_QUIT, WM_SYSCOLORCHANGE, WM_ENDSESSION, WM_SYSTEMERROR,
							WM_WININICHANGE, WM_DEVMODECHANGE, WM_ACTIVATEAPP, WM_FONTCHANGE, WM_TIMECHANGE,
							WM_SPOOLERSTATUS, WM_COMPACTING, WM_POWER, WM_INPUTLANGCHANGEREQUEST, WM_INPUTLANGCHANGE,
							WM_USERCHANGED, WM_DISPLAYCHANGE]) or (msg >= WM_POWERBROADCAST) then begin
		EnterCriticalSection(MsgHandlerSection^);
		try
			for i1 := 0 to high(MsgHandlerWindows) do
				if MsgHandlerWindows[i1].window = window then begin
					mh := Copy(MsgHandlerWindows[i1].handlers);
					break;
				end;
		finally LeaveCriticalSection(MsgHandlerSection^) end;
		for i1 := 0 to high(mh) do
			if mh[i1].message = msg then
				if @mh[i1].handler <> nil then
						 mh[i1].handler  (window, msg, wParam, lParam, result)
				else mh[i1].handlerOO(window, msg, wParam, lParam, result);
	end;
end;


procedure TdebuggertestForm.FormCreate(Sender: TObject);
var
	ob: dword;
begin
	ob := getOffsetBase;
	debuggerTestForm.Caption := debuggerTestForm.Caption + format('(offset base: $%p)',[pointer(ob)]);
end;

procedure TdebuggertestForm.genError;
begin
	// bad! esp destroying
	asm
		mov	esp,100000
	end;
end;

procedure TdebuggertestForm.stackOverflowErroButtonClick(Sender: TObject);
begin
	if handleCheckBox.Checked then begin
		try
			recursiveCall;
		except
		end;
	end
	else
		recursiveCall;
end;

procedure TdebuggerTestForm.recursiveCall;
begin
	recursiveCall;
end;

procedure TdebuggertestForm.callGenError;
begin
	genError;
end;

procedure TdebuggertestForm.userObjectsOverflowButtonClick(Sender: TObject);
var
	l: longword;
	h: THandle;

	procedure createWindows;
	begin
		repeat
			h := create_Window;
			inc(l);
		until h = 0;
	end;

begin
	if handleCheckBox.Checked then begin
		try
			createWindows;
		except
			showmessage('Handled resource guzzler error!');
		end;
	end
	else
		createWindows;
end;

function TdebuggertestForm.create_Window: cardinal;
const
	windowName = 'DummyWindow';
var
	wndClass: TWndClass;
	l: integer;
begin
	zeroMemory(@wndClass, sizeOf(wndClass));
	wndClass.lpfnWndProc   := @dummyHandlerWindowProc;
	wndClass.hInstance     := getModuleHandle(nil);
	wndClass.lpszClassName := windowName;
	windows.RegisterClass(wndClass);
	result := CreateWindowEx(WS_EX_TOOLWINDOW, windowName, '', WS_POPUP, 0, 0, 0, 0, 0, 0, getModuleHandle(nil), nil);
end;

procedure TdebuggertestForm.fatalExit2ButtonClick(Sender: TObject);
begin
	if handleCheckBox.Checked then begin
		try
			genFatalExit;
		except
		end;
	end
	else
		genFatalExit;
end;

procedure TdebuggertestForm.genFatalExit;
var
	oldProtect: pointer;
	oldAllocType: dword;
	memArea: array[0..1024] of byte;
	wBuff: array[0..1024] of byte;
	nWritedBytes: dword;
	baseAddr: pointer;
begin
	// error in here
	baseAddr := virtualAlloc(@memArea, sizeOf(memArea), MEM_COMMIT, PAGE_READONLY);
	showmessage('VirtualAlloc Executed!');
	if virtualProtect(@memArea, sizeOf(memArea), PAGE_READONLY, oldProtect) then begin
		showmessage('VirtualProtect Executed!');
		repeat
			writeProcessMemory(getCurrentProcess, @memArea, @wBuff, sizeOf(wBuff), nWritedBytes);
			showmessage('WriteProcessMemory Executed!');
		until true;
	end;
end;


procedure TdebuggertestForm.debugStringButtonClick(Sender: TObject);
begin
	outputDebugString('Sample output debug string.');
end;

procedure TdebuggertestForm.createProcessButtonClick(Sender: TObject);
begin
	fillChar(procinfo, sizeof(TProcessInformation), 0);
	fillChar(startinfo, sizeof(TStartupInfo), 0);
	win32Check(createProcess(PChar(Application.ExeName), nil, nil, nil, true, NORMAL_PRIORITY_CLASS, nil, nil, startInfo, procInfo));
	self.Left := self.Left - 21;
	self.Top := self.Top - 21;
	procCreated := true;
	createProcessButton.Enabled := false;
	exitProcessButton.Enabled := true;
end;

procedure TdebuggertestForm.exitProcessButtonClick(Sender: TObject);
begin
	if procCreated then begin
		terminateProcess(procInfo.hProcess, 0);
		procCreated := false;
	end;
	createProcessButton.Enabled := true;
	exitProcessButton.Enabled := false;
end;

{ TCreatorThread }

procedure TSampleThread.Execute;
var
	l: longword;
begin
	L := 0;
	repeat
		inc(L);
	until Terminated;
end;

procedure TdebuggertestForm.createThreadButtonClick(Sender: TObject);
begin
	t1 := TSampleThread.Create(true);
	t1.Resume;
	exitThreadButton.Enabled := true;
	createThreadButton.Enabled := false;
end;

procedure TdebuggertestForm.exitThreadButtonClick(Sender: TObject);
begin
	t1.Terminate;
	exitThreadButton.Enabled := false;
	createThreadButton.Enabled := true;
end;

procedure TdebuggertestForm.loadDllButtonClick(Sender: TObject);
var
	procName: string;
	sampleProcAddr: pointer;
begin
	dllHandle := LoadLibrary('sampleDll.dll');
	procName := 'sampleProc';
	sampleProcAddr := getProcAddress(dllHandle, pchar(procName));
	loadDllButton.Enabled := false;
	unloadDllButton.Enabled := true;
end;

procedure TdebuggertestForm.unloadDllButtonClick(Sender: TObject);
begin
	freeLibrary(dllHandle);
	loadDllButton.Enabled := true;
	unloadDllButton.Enabled := false;
end;

procedure TdebuggertestForm.divideByZeroErrorButtonClick(Sender: TObject);
var
	a,b,c: integer;
begin
	a := 100;
	b := 0;
	if handleCheckBox.Checked then begin
		try
			c := a div b;
		except
			showmessage('Handled divide by zero error!');
		end;
	end
	else
		c := a div b;
end;


procedure TdebuggertestForm.invalidPtrErrorButtonClick(Sender: TObject);
var
	p: pointer;

	procedure dummy;
	asm
	end;

begin
	p := @dummy;
	if handleCheckBox.Checked then begin
		try
			dispose(p);
		except
			showmessage('Handled error!');
		end;
	end
	else
		dispose(p);
end;

procedure TdebuggertestForm.closeButtonClick(Sender: TObject);
begin
	close;
end;

initialization


finalization

end.

